<?php
/*
Plugin Name: 123 No Rewrite Permalink
Plugin URI: http://putzlowitsch.de/123-no-rewrite-permalink
Description: Ermöglicht die Verwendung von Permalinks ohne mod_rewrite. Das ErrorDocument 404 wird "mißbraucht".
Author: Ingo Henze
Version: 0.15
Author URI: http://putzlowitsch.de/
*/ 

/*
Codevereinfachung ab Version 0.15 inspiriert vom Plugin mg404Rewrite von Michael Gustav Simon 
Plugin: http://blog.mgsimon.de/mg404rewrite/
Author: http://blog.mgsimon.de
*/

// Ersetzt die mod_rewrite-Regeln durch das ErrorDocument
function plw123nrp_mod_rewrite_rules( $rules ) {
  global $wp_rewrite;
 
	$home_root = parse_url( get_settings('home') );
	$home_root = trailingslashit( $home_root['path'] );
	$newrules  = "# Alle '404 Not Found'-Fehler auf index.php umleiten\n";
	$newrules .= "# ersetzt die mod_rewrite-Regeln durch ErrorDocument 404\n";
	$newrules .= "# siehe http://schnurpsel.de/wordpress-bei-strato/wordpress-permalinks.html\n";
	$newrules .= "ErrorDocument 404 $home_root$wp_rewrite->index";
	$rules = preg_replace( '~<IfModule mod_rewrite\.c>.+?</IfModule>~is', $newrules, $rules ); 
  return $rules;
}
add_filter( 'mod_rewrite_rules', 'plw123nrp_mod_rewrite_rules', 66 );
add_filter( 'rewrite_rules', 'plw123nrp_mod_rewrite_rules', 66 );  // alte Filter-Funktion


// Falls nicht vorhanden, plw123_debugfile_write Dummy definieren
if ( !function_exists('plw123_debugfile_write') ) :
function plw123_debugfile_write( $message) {
}
endif;

function plw123nrp_feed() {
  plw123_debugfile_write( 'plw123nrp_feed:'.$_SERVER['REQUEST_URI'] );
	if( preg_match( '/feed/i', $_SERVER['REQUEST_URI'] ) ) {
  	plw123_debugfile_write( 'is_feed' );
    add_filter( 'query_vars', 'plw123nrp_query_vars' );
	}
}

// häng sich am Anfang von 'template_redirect' rein,
// um gegebenfalls den echten Status 404 zu behandeln
function plw123nrp_template_redirect() {
	if( !is_404() && !is_trackback() ) {
		plw123_debugfile_write( "Status set to 404" );
		@header( "Status: 202 OK" );
	}	
}

// Da die POST-Daten verloren gehen, funktionieren Trackbacks nur ohne Permalink
// mit direktem Aufruf der wp-trackback.php 
function plw123nrp_trackback_url( $tb_url ) {
	global $id;
	if ( '' != get_option('permalink_structure') ) {
		$tb_url = preg_replace( "'(http://[^/]*)(.*)'i", "$1/index.php$2", $tb_url );
	}
	else {
		$tb_url = get_option('siteurl') . '/wp-trackback.php?p=' . $id;
	}
	return $tb_url;
}
add_filter( 'trackback_url', 'plw123nrp_trackback_url' );

// Nur wenn es eine ErrorDocument 404 Weiterleitung ist
if( $_SERVER['REDIRECT_STATUS'] == '404' )
{
	plw123_debugfile_write( "Status 404" );
	
	// die verlorengegangenen $_GET-Variablen rekonstruieren
	if( isset( $_SERVER['REDIRECT_QUERY_STRING'] ) )
		parse_str( $_SERVER['REDIRECT_QUERY_STRING'], $_GET );

	// die verlorengegangenen $_POST-Variablen rekonstruieren
	// das funktioniert nur leider nicht :-(
	/*if( isset( $_SERVER['CONTENT_LENGTH'] ) ) {
		$fp = fopen( 'php://stdin', 'r' );
	  $plw_post_vars = fread( $fp, $_SERVER['CONTENT_LENGTH'] ); 
		// ... 
		fclose( $fp );
	}*/

  add_action( 'template_redirect', 'plw123nrp_template_redirect' );
}

?>